> For the complete documentation index, see [llms.txt](https://docs.flatredball.com/flatredball/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.flatredball.com/flatredball/api/glue-plugin-api/flatredball-glue/vshelpers/codebuilditemadder.md).

# codebuilditemadder

### Introduction

The CodeBuildItemAdder provides methods for adding entire .cs files into game projects. Entire files may be needed in projects for a number of reasons:

* As a cross-platform way to embed classes which are needed by a plugin, such as a runtime type for a file
* To create singletons which are used to simplify code generation in each screen or entity
* To provide utility methods to be used in custom code

### Example Usage

The steps for adding code to a project using the CodeBuildItemAdder are:

1. Add a .cs file to your project as an embedded resource:

   ![](/files/9hZ2VPCMHCEYZGbmX7lW)
2. (Optional) Set the namespace to use the $PROJECT\_NAMESPACE$ keyword to indicate that it should match the game project's namespace:

   ```lang:c#
   namespace $PROJECT_NAMESPACE$.OcularPlaneRuntime
   {
   ```
3. Add the code to embed the class. Embedded resources use the '.' character to separate folders, so if your file in the project is located at MyPlugin/EmbeddedCodeFiles/CodeFile.cs, then your code to add the file would be as shown in the following snippet:

   ```lang:c#
   var adder = new CodeBuildItemAdder();
   adder.OutputFolderInProject = "PluginFiles";
   adder.AddFileBehavior = AddFileBehavior.IfOutOfDate;
   adder.Add("MyPlugin.EmbeddedCodeFiles.CodeFile.cs");
   ```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.flatredball.com/flatredball/api/glue-plugin-api/flatredball-glue/vshelpers/codebuilditemadder.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
